function a=monoto(a,ipres)
% entfernt Zyklen, die nicht streng monoton steigend,
% (bzw. fallend) in der Variablen auf Posotion ipres
% sind.
% bei ipres<0 wird streng fallend monotonisiert, sonst
% steigend
[iS,j]=size(a);
if ipres==0; error('ipres=0'); end
if abs(ipres)>j; error('ipres zu gross'); end

if ipres<0
 ipres=abs(ipres);
 Pmin=a(1,ipres);
 for i=2:iS
     if a(i,ipres)>Pmin;
        a(i,ipres)=NaN;
     else
        Pmin=a(i,ipres);
     end
 end
else
 Pmax=a(1,ipres);
 for i=2:iS
     if a(i,ipres)<Pmax;
        a(i,ipres)=NaN;
     else
        Pmax=a(i,ipres);
     end
 end
end

i=isnan(a(:,ipres));
a=a(~i,:);
